"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.XTemplate = void 0;
const tslib_1 = require("tslib");
const handlebars_1 = tslib_1.__importDefault(require("handlebars"));
const js_yaml_1 = tslib_1.__importDefault(require("js-yaml"));
const xregex_helpers_1 = tslib_1.__importDefault(require("@nodeplusplus/xregex-helpers"));
const helpers = tslib_1.__importStar(require("./helpers"));
class XTemplate {
    constructor() {
        helpers.template.register(handlebars_1.default);
    }
    compile(input, options) {
        const compile = handlebars_1.default.compile(input);
        const content = compile(Object.assign({}, options === null || options === void 0 ? void 0 : options.ref), {});
        const schema = new js_yaml_1.default.Schema({ include: [js_yaml_1.default.DEFAULT_FULL_SCHEMA] });
        const template = js_yaml_1.default.safeLoad(content, { schema, json: true });
        const override = (options === null || options === void 0 ? void 0 : options.override) && helpers.parseKeyValue(options.override);
        return xregex_helpers_1.default.merge({}, template, options === null || options === void 0 ? void 0 : options.values, override);
    }
    dump(input, options, json = false) {
        const template = this.compile(input, options);
        if (json)
            return template;
        return js_yaml_1.default.dump(template);
    }
}
exports.XTemplate = XTemplate;
