"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseKeyValue = void 0;
const flat_1 = require("flat");
function parseKeyValue(templates, separator = "=") {
    const pairs = templates
        .filter(filter.bind(null, separator))
        .map(split.bind(null, separator));
    const options = Object.assign({}, ...pairs);
    return flat_1.unflatten(options, { object: false });
}
exports.parseKeyValue = parseKeyValue;
function filter(separator, template) {
    return template && template.includes(separator);
}
function split(separator, pairs) {
    const [key, value] = pairs.split(separator).map((p) => p.trim());
    return { [key]: value };
}
